/*
 * This file is part of AppC.
 * Copyright (C) 2004 Sascha Boehme
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "AppC.h"



/* a collection of matrix functions (see 'algorithm_initialize()') */
static MatrixFunctions matrixFunctions;





static void compute(Matrix result, const Matrix initial)
{
    /* execute the algorithm itself computing 'result' by using 'initial' */
}

static void prepare(const Matrix initial)
{
    /* store a copy of 'initial' in a global variable and do some
     * other initializations before 'compute_next_step()' is called */
}


static gboolean compute_next_step(Matrix result)
{
    /* execute one step of the algorithm and copy the result into 'result' */

    /* return TRUE if there is another step after the one just computed */
    return ;
}



G_MODULE_EXPORT void algorithm_initialize(Algorithm alg,
                                          const MatrixFunctions *mf)
{
    /* fill in the algorithm structure for the algorithm */
    alg->compute = compute;
    alg->prepare = prepare;
    alg->compute_next_step = compute_next_step;


    /* copy the matrix functions structure for our own use */
    matrixFunctions.create_matrix = mf->create_matrix;
    matrixFunctions.copy_matrix = mf->copy_matrix;
    matrixFunctions.free_matrix = mf->free_matrix;
}
