/*
 * This file is part of AppC.
 * Copyright (C) 2004 Sascha Boehme
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "View.Private.h"



/* Create a window showing some general program information. */
void v_show_about_dialog(void)
{
    static GtkWidget *dialog = NULL;

    /* create the dialog only once */
    if (dialog == NULL)
    {
        GtkWidget *rootPanel;
        GtkWidget *label;

        dialog = gtk_dialog_new_with_buttons(
                            _T("About AppC"),
                            v_get_main_window(),
                            GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
                            _T("OK"),
                            GTK_RESPONSE_ACCEPT,
                            NULL);

        rootPanel = GTK_DIALOG(dialog)->vbox;

        label = gtk_label_new("");
        gtk_label_set_markup(GTK_LABEL(label),
                             "<b><big>AppC - The Algebraic Path Problem "
                             "Calculator</big></b>");
        gtk_misc_set_alignment(GTK_MISC(label), 0, 0);
        gtk_misc_set_padding(GTK_MISC(label), 12, 12);
        gtk_box_pack_start(GTK_BOX(rootPanel), label, FALSE, FALSE, 0);
        gtk_widget_show(label);

        label = gtk_label_new("Copyright \xC2\xA9 2004 Sascha B\xC3\xB6hme\n"
                              "Design by Susann M\xC3\xBCller");
        gtk_misc_set_alignment(GTK_MISC(label), 0, 0);
        gtk_misc_set_padding(GTK_MISC(label), 12, 12);
        gtk_box_pack_start(GTK_BOX(rootPanel), label, FALSE, FALSE, 0);
        gtk_widget_show(label);
    }

    /* show the dialog and hide it after "OK" was pressed */
    gtk_dialog_run(GTK_DIALOG(dialog));
    gtk_widget_hide(dialog);
}
